if {[regexp {[]\(\)\"\{\}\[]} $HOME]} {alertnote "Alpha may not work properly if it's pathname includes parenthesis, square brackets, double quotes, or curly braces."}

proc quoteExpr str {
	regsub -all {\\} $str {\\\\} str
	regsub -all {\|} $str {\|} str
	regsub -all {\*} $str {\\*} str
	regsub -all {\+} $str {\\+} str
	regsub -all {\(} $str {\\(} str
	regsub -all {\)} $str {\\)} str
	regsub -all {\[} $str {\\[} str
	regsub -all {\]} $str {\\]} str
	return $str
}

proc quoteExpr2 str {
	regsub -all {\\} $str {\\\\} str
	regsub -all {\|} $str {\|} str
	regsub -all {\*} $str {\\*} str
	regsub -all {\+} $str {\\+} str
	regsub -all {\(} $str {\\(} str
	regsub -all {\)} $str {\\)} str
	regsub -all {\{} $str "\\\{" str
	regsub -all {\}} $str "\\\}" str
	regsub -all {\[} $str {\\[} str
	regsub -all {\]} $str {\\]} str
	return $str
}
# Alpha 5.x Init File
# Change the first number to '1' if you are using an international keyboard.
init 0 2
set optionIsMeta 1

source ":Tcl:SystemCode:menus.tcl"

# Examples of using C-x and C-c combinations for you emacs freaks.
bind 'x' <z> 	prefixChar
bind 'c' <z> 	prefixChar
bind 'l' <X>	currentPosition
bind '(' <sX>	startKeyboardMacro
bind ')' <Xs>	endKeyboardMacro
bind 'e' <X>	executeKeyboardMacro
bind 'f' <Xz>	findFile
bind 's' <Xz>	save
bind 'x' <e>	execute
bind 'x' <Xz>	exchangePointAndMark
bind 'o' <X>	nextWindow
bind 'm' <X>	matchingLines

# Another control prefix.
bind 'q' <z> 	prefixChar
bind 'a' <Q>	shrinkHigh
bind 'b' <Q>	shrinkLow
bind 'c' <Q>	chooseAWindow
bind 'h' <Q>	horizontally
bind 'i' <Q>	iconify
bind 'n' <Q>	nextWindow
bind 'o' <Q>	overlay
bind 'p' <Q>	prevWindow
bind 's' <Q>	swapWithNext
bind 't' <Q>	tiled
bind 'v' <Q>	vertically


bind 'w' <zs>	rectMarkHilite
bind '\r'		carriageReturn
bind '\t' 		tclFileCompletion "Csh"
ascii 0x1b		startEscape
ascii 0x8		backSpace
bind "'	'" <z>	indentLine
bind 's' <zoc>	spacesToTabs
bind 't' <zoc>	tabsToSpaces
bind 'a' <zo>	insertAscii
bind 'a' <zos>	getAscii
# bind 'l' <xo>	currentPosition
bind 'f' <cz> 	freeMem
# bind 'd' <zx>	deleteSelection
# bind 'l' <x> 	currentPosition
bind 'r' <e> 	repeatSearchBackward
bind 's' <e> 	repeatSearchForward
bind '\ ' <e>	oneSpace
bind 'j' <e>	fillRegion
bind 'p' <e>	fillParagraph
bind 'b' <e> 	backwardWord
bind 'b' <es>	backwardWordSelect
bind 'd' <e> 	deleteWord
bind 'f' <e> 	forwardWord
bind 'f' <es> 	forwardWordSelect
bind 'g' <e> 	gotoLine
bind 'h' <e> 	backwardDeleteWord
bind '<' <se> 	beginningOfBuffer
bind '>' <se> 	endOfBuffer
bind 't' <e> 	findTag
bind 'k' <e> 	keyCode
bind 'l' <e>	downcaseWord
bind 'u' <e>	upcaseWord
bind 'c' <e>	capitalizeWord
bind 'e' <e> 	nextSentence
bind 'a' <o> 	prevSentence

bind Left  backwardChar
bind Left <c> beginningOfLine
bind Left <s> backwardCharSelect
bind Left <sc> beginningLineSelect
bind Left <z> {scrollLeftCol 15}
bind Left <o> backwardWord
bind Left <os> backwardWordSelect

bind Right  forwardChar
bind Right <c> endOfLine
bind Right <s> forwardCharSelect
bind Right <sc> endLineSelect
bind Right <z> {scrollRightCol 15}
bind Right <o> forwardWord
bind Right <os> forwardWordSelect

bind Up  previousLine
bind Up <s> prevLineSelect
bind Up <c> beginningOfBuffer
bind Up <sc> beginningBufferSelect
bind Up <z> scrollUpLine
bind Up <o> scrollUpLine

bind Down  nextLine
bind Down <c> endOfBuffer
bind Down <s> nextLineSelect
bind Down <sc> endBufferSelect
bind Down <z> scrollDownLine
bind Down <o> scrollDownLine

# Keypad definitions
bind KPad4  backwardWord 				
bind KPad4   <c> backwardDeleteWord 
bind KPad6   forwardWord 				
bind KPad6   <c> deleteWord 
bind Clear   insertToTop 				
# Never bind Keypad /
# Never bind Keypad *
bind KPad0   pageBack 					
bind Enter   pageForward
;bind KPad3   repeatSearchForward 		
;bind KPad1   repeatSearchBackward 	
bind Kpad1 prevFunc
bind Kpad3 nextFunc
bind KPad.   endOfBuffer 				
bind KPad5   exchangePointAndMark 	
bind KPad7   backwardDeleteWord 		
bind KPad9   deleteWord 				
bind 's' <z> 	isearch			
bind 'r' <z> 	rsearch			
bind 'a' <z> 	beginningOfLine	
bind 'b' <z> 	backwardChar		
bind 'd' <z> 	deleteChar		
bind 'f' <z> 	forwardChar		
bind 'e' <z> 	endOfLine		
bind 'g' <z> 	abortEm			
bind 'k' <z> 	killLine			
bind 'l' <z>	centerRedraw
bind 't' <z> 	insertToTop		
bind 'p' <z> 	previousLine		
bind 'n' <z> 	nextLine			
bind 'o' <z> 	openLine			
bind 'u' <z> 	iterationCount	
bind 'v' <z> 	pageForward		
bind 'v' <e> 	pageBack
bind 'z' <z> 	pageBack
bind 'w' <z> 	cut			
bind 'w' <e> 	copy
bind "' '" <z> 	setMark			
bind 'y' <z> 	yank				

# Alpha variable and flag definitions.
set temp [getMainDevice]
set tileWidth [expr {[lindex $temp 2] - [lindex $temp 0] - 10}]
if {$tileWidth > 510} {set defWidth 510} else {set defWidth $tileWidth }
set tileHeight [expr {[lindex $temp 3] - [lindex $temp 1] - 45}]
set defHeight $tileHeight
unset temp

source ":Tcl:SystemCode:definitions.tcl"


# Color support
# colors -20481 2703 2703 -632 -588 -11060
colors 0 0 0 -588 -818 -1507

bind F1     iconify 					
bind F2     cut 						
bind F3     copy 						
bind F4     yank 						
bind F5     prevWindow
bind F6		nextWindow
bind F7		tiled
bind F8		swapWithNext
bind F9     pushMark
bind F10    popMark
bind F11    shrinkHigh
bind F12    shrinkLow
bind F13    startKeyboardMacro 		
bind F14    endKeyboardMacro 			
bind F15    executeKeyboardMacro 		

bind Del    deleteChar 				
bind Help   alphaHelp 					
bind Home   beginningOfBuffer 			
bind End    endOfBuffer 				
bind Pgup   pageBack 					
bind Pgdn   pageForward  				

proc debug {} {
	uplevel #0 {
		set debugging 1
		shadowVar debugging
	}
}

proc editFlag {menu item} {
	global $item
	set val [expr ([set $item]-1)*-1]
	set $item $val
}

proc editVar {menu item} {
	global $item
	append prmpt "New Value of " $item ": "
	if ![catch {prompt $prmpt [set $item]} res] {
		set $item $res
	}
}

# Load electric alias, rebind tcl file completion for precedence.
proc loadElectricAlias {} {
	global HOME
	uplevel #0 {
		source "$HOME:Tcl:ElectricAlias:electricAlias.tcl"
	}
	message "ElectricAlias loaded."
	bind '\t' tclFileCompletion "Csh"
	enableMenuItem Misc loadElectricAlias off
}

menu -n Tcl {
	"traceTclProc"
}


source ":Tcl:SystemCode:flags.tcl"
source ":Tcl:SystemCode:filesets.tcl"
source ":Tcl:SystemCode:procs.tcl"
source ":Tcl:SystemCode:copyRing.tcl"
set auto_path [list $HOME:Tcl:SystemCode $HOME:Tcl:UserCode]
source ":Tcl:SystemCode:library.tcl"


# Use "userStartup.tcl" to define or change any tcl information. */
if {[file exists ":userStartup.tcl"]} {
	source  ":userStartup.tcl"
}

