# My menus.		

menu	-n Utilities {
		"longMenus"
		{menu -n fileUtils {
			"insertFile"
			"(-"
			"fileRemove"
			"fileInfo/="}}
		{menu -n fileSets -m -p changeFileSet ""}
		{menu -n Clips {
			"copyNamedClipboard"
			"cutNamedClipboard"
			"pasteNamedClipboard"}}
		"(-"
		{menu -n arrange {
			"vertically^1"
			"horizontally^2"
			"tiled^3"
			"overlay^4"}}
		"zoom//"}


menu	-n "Utils" {
		"shortMenus"
		{menu -n Flags -p editFlag {}}
		{menu -n Vars -p editVar {}}
		{menu -n fileUtils {
			"insertFile"
			"fileRemove"
			"fileInfo"
			"wordCount"}}
		"(-"
		{menu -n fileSets ""}
		"createFileset"
		"dumpFileset"
		"findTag"
		"createTagFile"
		"(-"
		"/'execute"
		"(-"
		"pushMark"
		"popMark"
		"prevFunc"
		"nextFunc"
		"(-"
		"startKeyboardMacro"
		"endKeyboardMacro"
		"executeKeyboardMacro"
		"dumpMacro"}

proc helpMenu {menu item} {
	global HOME
	edit -r -m $HOME:Help:$item
}

proc strip {arg} {
	if {[regsub -all {\\([][\{\}])} $arg {\1} v]} {return $v}
	return $arg
}

# Boy, this is ugly. 'files' comes w/ backquotes from glob, must get rid 
# of them. 'temp' arrives w/o quotes before chars that 'regsub' will 
# interpret as special regular expression characters.
set temp "$HOME:Help:"
if {![catch {glob $temp*} files]} {
	if {![regsub -all [quoteExpr2 $temp] [strip $files] "" temp2]} {
		alertnote "Trouble building help menu."
		menu -n Help ""
	} else {
		menu -n Help -m -p "helpMenu" $temp2
	}
}	
catch {unset temp temp2 files}


proc menuModeProc {menu item} {
	newMode $item
}

menu	-n Misc {
		"pastePop/."
		"(-"
		"listBindings"
		"describeBinding"
		"insertPathName"
		"setFontsTabs"
		"(-"
		"copyNamedClipboard"
		"cutNamedClipboard"
		"pasteNamedClipboard"
		"(-"
		{menu -n asciiEtc {
			"keyCode"
			"keyAscii"
			"getAscii"
			"insertAscii"}}
		{menu -n Modes -m -p menuModeProc {
			"/,C"
			"C++"
			"Csh"
			"Fort"
			"MPW"
			"Tcl"
			"Tex"
			"Text"}}
		{menu -m -n switchTo -p switchProc {
			"/`MacMiNT"
			"THINK Project Manager"
			"MPW Shell"
			"Versaterm PRO"
			"MacLayers"}}
		"toolserverShell"
		"(-"
		"loadElectricAlias"
}

proc switchProc {menu name} {
	switchTo $name
}
		

menu	-n Convert {
		"fillRegion"
		"fillParagraph"
		"wrapRegion"
		"wrapParagraph"
		"sortLines"
		"matchingLines"
		"(-"
		"zapInvisibles"
		"tabsToSpaces"
		"spacesToTabs"
		"(-"
		{menu	-n Strings {
			"insertPrefix"
			"insertSuffix"
			"removePrefix"
			"removeSuffix"
			"setPrefix"
			"setSuffix"}}
		{menu 	-n Colors {
			"foreColor"
			"backColor"
			"dumpColors"}}
		"(-"
		"ParagraphToLine"
		"LineToParagraph"}


menu -n Wins -p menuWin {
		{menu -n arrange {
			"vertically^1"
			"horizontally^2"
			"tiled^3"
			"overlay^4"}}
		"//zoom"
		"iconify"
		"(-"
		"nextWindow"
		"swapWithNext"
		"chooseAWindow/;"
		"prevWindow"
		"closeAll"
		"saveAll"
		"(-"
}


# We may be reloading, so add whatever windows we have
if {[info exists winNameToNum]} {
	set nms [array names winNameToNum]
	foreach name $nms {
		if {$fullNames} {
			set item $name
		} else {
			regexp {[^:]*$} $name item
		}
		set num $winNameToNum($name)
		if {$num < 10} 	{
			addMenuItem -m Wins /$num$item
		} else {
			addMenuItem -m Wins $item
		}
	}
}

insertMenu "Utils"
insertMenu "Misc"
enableMenuItem Misc pasteNamedClipboard off
insertMenu "Convert"
insertMenu "Help"
insertMenu "Wins"

proc shortMenus {} {
	removeMenu "Utils"
	removeMenu "Misc"
	removeMenu "Convert"
	removeMenu "Wins"
	insertMenu "Utilities"
}

proc longMenus {} {
	removeMenu "Utilities"
	insertMenu "Utils"
	insertMenu "Misc"
	insertMenu "Convert"
	insertMenu "Wins"
}


