#=============================================================================
# 'Strings' commands - Thanks, Mark Nagata
#=============================================================================

proc setPrefix {} {
	global prefixString
	if {[catch {prompt "New Prefix String:" $prefixString} res] == 1} return
	set prefixString $res
}

proc setSuffix {} {
	global suffixString
	if {[catch {prompt "New Suffix String:" $suffixString} res] == 1} return
	set suffixString $res
}

proc insertSuffix {} {doSuffix insert}
proc removeSuffix {} {doSuffix remove}
proc doSuffix {which} {
	global suffixString
	set suff [quoteExpr $suffixString]
	set start [getPos]
	set end [selEnd]
	set start [lineStart $start]
	set end [nextLineStart [expr $end-1]]
	set text [getText $start $end]
	deleteText $start $end
	if {$which == "insert"} then {
		set str ${suffixString}\r
		regsub -all \r $text $str text
	} else {
		set str ${suff}\r
		regsub -all $str $text \r text
	}
	insertText $text
	select $start [expr {$start+[string length $text]}]
}


proc insertPrefix {} {doPrefix insert}
proc removePrefix {} {doPrefix remove}
proc doPrefix {which} {
	global prefixString
	set pref [quoteExpr $prefixString]
	set start [getPos]
	set end [expr [selEnd]-1]
	if {$end<$start} {set end $start}
	set start [lineStart $start]
	set text [getText $start $end]
	if {$which == "insert"} then {
		set str \r$prefixString
		regsub -all \r $text $str text
		set	text "$prefixString$text"
		replaceText	$start $end	$text
	} else {
		set str \r$pref
		regsub -all $str $text \r text
		regsub ^$pref $text "" text
		replaceText $start $end $text
	}
	select $start	[expr	{$start+[string	length $text]+1}]
}

