#================================================================================
# This is my current 'userStartup.tcl'. Use this as an example of what can
# be done. Do not use any of this directly, as the your files are doubtless in
# different locations than mine.
#================================================================================



#================================================================================
# The following is a script that creates a menu for all the .tex files in my 
# thesis directory, minus the dirname and .tex extension.
#
set THESIS "Internal:Textures:thesis"
proc thesisMenuProc {menu item} {
	global THESIS
	edit -r -m $THESIS:$item.tex
}

foreach f [glob $THESIS:*.tex] {
	lappend files [file rootname [file tail $f]]
}
menu -n Thesis -m -p thesisMenuProc $files
unset files

#================================================================================
# Redefinition of 'latex' from latex.tcl. It sends an additional open event to 
# Textures. 
proc latex {} {
	global latexPath
	set sig ""
	catch {string trim [lindex [getfinfo $latexPath] 1] '} sig
	set name [checkRunning latex $sig latexPath]
	if {![string length $name]} return
	switchTo $name
	catch {sendOpenEvent -n $name [lindex [winNames -f] 0]}
}

#================================================================================

set backup 1
if {[file exists "Internal:Development:Alpha"]} {
	set fileSets(Edit) [glob -t TEXT "Internal:Development:Alpha:EditSource:*.c"]
	addMenuItem -m fileSets "Edit"
}
set thinkName "Internal:Development:Symantec C++ for Macintosh:THINK Project Manager"
set excaliburPath "Internal:Textures:Excalibur1.4.1:Excalibur 1.4.1"
set latexPath "Internal:Textures:Textures 1.6.2a1"
set toolserverPath "Internal:Utils:ToolServer"
set referencePath "Internal:Buckaroo:Buckaroo 2.0b1"

